#include "tricks.h"

#include <conio.h>
#include <stdio.h>

struct facep
{
   float x,y,z;
   float px,py;
};

// ********

static facep kubp[8];
static facep rotp[8];
static int   kubf[6][4];

static int startx[200];
static int endx[200];

static int y_tab[200];

// ********

static void initpoint( int point, float x, float y, float z);
static void initface ( int face, int a, int b, int c, int d);

static void initall();

static void rotate();
static void project();

static void polydraw();
static void Poly( int Face , int color );
static void polyfix( int x1, int x2, int y1, int y2);
static void blah( int x1, int y1, int x2, int y2);

static byte buffer[64000];

// **********

int main()
{
   SetMCGA();

   initall();

   do
   {
      rotate();
      project();
      polydraw();
      WaitRetrace();

      memcpy( vga, buffer, 64000);
      memset( buffer, 0, 64000);

   } while ( !kbhit() );

   SetText();

   return 0;
}


// ************ DRAW ******************************************

void polyfix( int x1, int y1, int x2, int y2)
{
   if( y2 < y1 )  
   {
      int temp = y1;
      y1 = y2;
      y2 = temp;

      temp = x1;
      x1 = x2;
      x2 = temp;
   }

   if( y2 == y1 )
   {
      startx[y1] = x1;
      endx  [y1] = x2;
   }
   else
   {
      int X, Y, Step;
      X = x1 << 16;
      Step = ((x2-x1) << 16) / (y2-y1);
      X += Step;

      y1++;

      for( Y = y1; Y <= y2; Y++)
      {
         if(( Y>=0 )&( Y<200 ))
         {
            if( startx[ Y ] == -1)
               startx[ Y ] = (X >> 16);
            else
               endx[ Y ] = (X >> 16);
         }

         X += Step;
      }
   }
}

void polydraw()
{
   for( int i=0; i<6; i++ )
   {
      int p0 = kubf[i][0];
      int p1 = kubf[i][1];
      int p2 = kubf[i][2];
      int p3 = kubf[i][3];

      float norm =   ((rotp[p3].y - rotp[p0].y) * (rotp[p1].x - rotp[p0].x))
                   - ((rotp[p1].y - rotp[p0].y) * (rotp[p3].x - rotp[p0].x));

      if( norm < -0.3 )
         Poly( i , -norm *16);
   }
}

void Poly( int Face, int color )
{
   for( int i=0; i<200; i++)
   {
      startx[i] = -1;
        endx[i] = -1;
   }

   for( i=0; i<3; i++)
   {
      polyfix( rotp[ kubf[Face][i]   ].px,
               rotp[ kubf[Face][i]   ].py,
               rotp[ kubf[Face][i+1] ].px,
               rotp[ kubf[Face][i+1] ].py );
   }

   polyfix( rotp[ kubf[Face][3] ].px,
            rotp[ kubf[Face][3] ].py,
            rotp[ kubf[Face][0] ].px,
            rotp[ kubf[Face][0] ].py );


   for( i=0; i<200; i++ )
   {
      if( startx[i] != -1 )
      {         
         if( endx[i] == -1)
            startx[i] = endx[i];

         Line( startx[i], i, endx[i], i, color, buffer );
      }
   }
}

// ************ PROJECT ***************************************

void rotate()
{
   static double angle = 0;

   angle += 0.03;
	
   float sinX = sin(angle);
   float cosX = cos(angle);

   float sinY = sin(angle);
   float cosY = cos(angle);

   float sinZ = sin(angle);
   float cosZ = cos(angle);

   float temp;

   for( int i=0; i<8; i++)       
	{
      rotp[i].x = kubp[i].x * cosZ + kubp[i].y * sinZ;
      rotp[i].y = kubp[i].y * cosZ - kubp[i].x * sinZ;

      rotp[i].z = kubp[i].z * cosY - rotp[i].x * sinY;
      rotp[i].x = rotp[i].x * cosY + kubp[i].z * sinY;

      temp      = rotp[i].y * cosX + rotp[i].z * sinX;
      rotp[i].z = rotp[i].z * cosX - rotp[i].y * sinX;
      rotp[i].y = temp;
	}
}

void project()
{
   for( int i=0; i<8; i++ )
   {
      rotp[i].px = (( rotp[i].x / (rotp[i].z + 15)) * 700) + 160;      
      rotp[i].py = (( rotp[i].y / (rotp[i].z + 15)) * 650) + 100;      
   }
}

// ************* INITS *****************************************

void initall()
{
   for( int i=0; i<64; i++)
   {
      Pal( i,0,i,i );
   }

   for( i=0; i<200; i++ )
   {
      y_tab[i] = i*320;
   }

   for( i=0; i<200; i++)
   {
      startx[i] = -1;
        endx[i] = -1;
   }


   initpoint( 0,  1,  1, 1 );
   initpoint( 1,  1, -1, 1 );
   initpoint( 2, -1, -1, 1 );
   initpoint( 3, -1,  1, 1 );

   initpoint( 4,  1,  1, -1 );
   initpoint( 5,  1, -1, -1 );
   initpoint( 6, -1, -1, -1 );
   initpoint( 7, -1,  1, -1 );

   initface( 0, 0,3,2,1);
   initface( 1, 4,0,1,5);
   initface( 2, 7,4,5,6);
   initface( 3, 3,7,6,2);
   initface( 4, 7,3,0,4);
   initface( 5, 5,1,2,6);
}

void initpoint( int point, float x, float y, float z)
{
   kubp[point].x = x;
   kubp[point].y = y;
   kubp[point].z = z;
}

void initface ( int face, int a, int b, int c, int d)
{
   kubf[face][0] = a;
   kubf[face][1] = b;
   kubf[face][2] = c;
   kubf[face][3] = d;
}
   

void blah( int x1, int y1, int x2, int y2)
{
 int tmp,y;
 long x,m;

 if (y2 != y1)     /* This isn't a horizontal line */
 {
   if (y2 < y1)    /* Make sure y2 is greater than y1 */
   {
    tmp = y1;      /* Swap the y coordinate */
    y1 = y2;
    y2 = tmp;

    tmp = x1;      /* Swap the corresponding x coordinates */
    x1 = x2;
    x2 = tmp;
   }

 x = (long)x1<<8;  /* Multiply be 256 */

 m = ((long)(x2 - x1)<<8) / ((long)(y2 - y1));
 /* m is the fractional amount to add to the x coordinate every row.
    m is equal to (delta x) / (delta y).  In other words, the x coordinate
    has to change by (x2 - x1) columns in (y2 - y1) rows. */

 x += m; /* We ALWAYS skip the first point in every line. This is done */
 y1++; /* because we do not want to store the point where two lines
	  meet, twice.  This would result in a single point being drawn. */

 for (y = y1; y <= y2; y++) /* Go through each row */
  {
   if ((y >= 0) & (y < 200)) /* If the coordinate is on the screen */
    if (startx[y] == -16000) /* Store the first coordinate */
      startx[y] = x>>8;
    else
      endx[y] = x>>8;        /* Store the last coordinate */
   x += m;                   /* Add our constant to x */
   }
 }

}
